#include "B4RDefines.h"

namespace B4R {
	bool B4RASK::Initialize(SubVoidByteArray DataAvailableSub, byte ThisAddress, int Speed, byte RXpin, byte TXpin, byte PTTpin, bool PTTinverted) {
		this->DataAvailableSub = DataAvailableSub;
		FunctionUnion fu;
		fu.PollerFunction = looper;
		pnode.functionUnion = fu;
		pnode.tag = this;
		ask = new (backend) RH_ASK(Speed, RXpin, TXpin, PTTpin, PTTinverted);
		ask->setThisAddress(ThisAddress);
		ask->setHeaderFrom(ThisAddress);
		bool r = ask->init();
		if (r) {
		if (pnode.next == NULL)
				pollers.add(&pnode);
		}
		return r;
	}

	void B4RASK::looper(void* b) {
		B4RASK* me = (B4RASK*)b;
		
		if (me->ask->available()) {
			const UInt cp = B4R::StackMemory::cp;
			ArrayByte* arrPayload = CreateStackMemoryObject(ArrayByte);
			arrPayload->data = me->buffer;
			Byte len = RH_ASK_MAX_PAYLOAD_LEN;
			me->ask->recv(me->buffer, &len);
			arrPayload->length = len;
			me->DataAvailableSub(arrPayload);
			B4R::StackMemory::cp = cp;
		}
	}

	bool B4RASK::Send(Array* Data) {
		return ask->send((Byte*)Data->data, Data->length);
	}
	UInt B4RASK::getMaxMessageLength() {
		return RH_ASK_MAX_MESSAGE_LEN;
	}
	void B4RASK::setHeaderTo(Byte To) {
		ask->setHeaderTo(To);
	}
	Byte B4RASK::getHeaderTo() {
		return ask->headerTo();
	}
	void B4RASK::setHeaderFrom(Byte From) {
		ask->setHeaderFrom(From);
	}
	Byte B4RASK::getHeaderFrom() {
		return ask->headerFrom();
	}
	void B4RASK::setHeaderID(Byte ID) {
		ask->setHeaderId(ID);
	}
	Byte B4RASK::getHeaderID() {
		return ask->headerId();
	}
	void B4RASK::setHeaderFlags(byte Set, byte Clear){
		ask->setHeaderFlags(Set,Clear);
	}
	Byte B4RASK::getHeaderFlags() {
		return ask->headerFlags();
	}

}
